from datetime import datetime

from pydantic import BaseModel, PositiveInt, NegativeInt

from src.core.common.schemas import BaseModelWithSerializeDatetime


class MessageFromChatSchema(BaseModelWithSerializeDatetime):
    id: PositiveInt
    user_id: PositiveInt
    chat_id: NegativeInt
    text: str
    message_time: datetime


class ResponseFromAiSchema(BaseModel):
    user_id: PositiveInt | None
    chat_id: NegativeInt | None
    reason: str | None
