from pyrogram import filters, Client
from pyrogram.enums import ChatType
from pyrogram.types import Message

from src.core.ai_services.schemas import MessageFromChatSchema
from src.core.tg_service.constants import MESSAGE_CHANG_SIZE
from src.core.tg_service.service import check_user_exists, check_chat_exists
from src.core.tg_service import utils as api_tg_utils


DATA: dict[int, list[MessageFromChatSchema]] = dict()


async def some_publisher():
    pass


async def message_listener(client: Client, message: Message):
    if api_tg_utils.check_message_condition(message):
        await check_user_exists(
            user_pyrogram=message.from_user,
        )
        await check_chat_exists(
            chat_pyrogram=message.chat,
        )

        messages_chunk = DATA.get(message.chat.id)
        message_schema = MessageFromChatSchema(
            id=message.id,
            user_id=message.from_user.id,
            chat_id=message.chat.id,
            text=message.text,
            message_time=message.date,
        )


        if messages_chunk and len(messages_chunk) == MESSAGE_CHANG_SIZE:  # TODO в констант.
            await some_publisher()
            del DATA[message.chat.id]

        if messages_chunk:
            DATA[message.chat.id].append(message_schema)
        else:
            DATA[message.chat.id] = [message_schema]
